#!/usr/bin/perl
# 
# library - admin 
# == scripted by Takuya Otani ========
# == copyright (C) SimpleBoxes 2004 ==

{
	my $aVersion_ = 0.12;
	# 
	# ver 0.00 [2004/05/19] 
	# ver 0.01 [2004/06/02] ƹۥץб
	# ver 0.02 [2004/06/04] PING λѹ
	# ver 0.03 [2004/06/05] PING νͤǤ褦
	# ver 0.04 [2004/06/10] Ϣ html ե빹ԤʤХ, sbadmn_update_link ΥХ
	# ver 0.05 [2004/06/14] sbadmn_amazon ɲ
	# ver 0.06 [2004/06/22] ˥åѥե
	# ver 0.07 [2004/06/30] ѹΥб
	# ver 0.08 [2004/07/01] ˥ѥե
	# ver 0.09 [2004/07/09]  PING ե˹Ԥ褦
	# ver 0.10 [2004/07/11] Υк(sbadmn_check_entry_id ɲ), ǽγĥ
	# ver 0.11 [2004/07/16] ʣƥåΥХ
	# ver 0.12 [2004/07/19] ʸʤνɲ
	require 'sblock.pl';
	require 'sbtime.pl';
	require 'sbtext.pl';
	require 'sbpict.pl';
	require 'sbmake.pl';
}

sub sbadmn_regimode {
	my $mode = shift;
	my $msg = '';
	my $lfile = &sblock_lock() or die($gMsg{'error'}{'file_lock'} . "\n");
	eval {
		ADMINREGI: {
			$_ = $mode;
			/^edit$/ && do {
				$msg = &sbadmn_update_entry($gIn{'id'});
				last ADMINREGI;
			};
			/^upload/ && do {
				$msg = &sbadmn_update_image();
				last ADMINREGI;
			};
			/^link/ && do {
				$msg = &sbadmn_update_link();
				last ADMINREGI;
			};
			/^category/ && do {
				$msg = &sbadmn_update_category();
				last ADMINREGI;
			};
			/^profile|^user/ && do {
				$msg = &sbadmn_update_user($_);
				last ADMINREGI;
			};
			/^amazon/ && do {
				$msg = &sbadmn_amazon($gIn{'aid'});
				last ADMINREGI;
			};
			/^template/ && do {
				$msg = &sbadmn_update_template($gIn{'tid'});
				last ADMINREGI;
			};
			/^rebuild/ && do {
				if ($gIn{'rebuild_option'}) {
					&sbmake_top();
					&sbmake_rss()  if ($gEnv{'basic'}{'gen_rss'});
					&sbmake_atom() if ($gEnv{'basic'}{'gen_atom'});
					&sbmake_css();
					&sbmake_cookie_js(1);
					&sbmake_log_js(1);
				} else {
					&sbmake_rebuild_all();
				}
				$msg = $gMsg{'parts'}{'buildcmp'};
				last ADMINREGI;
			};
			/^list/ && do {
				$msg = '[' . $gMsg{'mode'}{$mode} . '] ' .  &sbadmn_delete_entry();
				last ADMINREGI;
			};
			/^comment|^trackback/ && do {
				$msg = '[' . $gMsg{'mode'}{$mode} . '] ' . &sbadmn_update_comtb($_);
				last ADMINREGI;
			};
			/^refuse/ && do {
				my $ban_list = &sbtxt_lfconv($gEnv{'conf'}{'ip_ban'},1);
				if ($gIn{'add'} ne '') {
					my $flag = 0;
					foreach my $ban_ip ( split("\n",$ban_list) ) {
						$flag = 1 if ($gIn{'refuse_ip'} eq $ban_ip);
						last if ($flag);
					}
					$gEnv{'conf'}{'ip_ban'} .= $gIn{'refuse_ip'} . '%n' if (!$flag);
				} elsif ($gIn{'del'} ne '') {
					$gEnv{'conf'}{'ip_ban'} = '';
					foreach my $ban_ip ( split("\n",$ban_list) ) {
						my $flag = 0;
						foreach my $del_ip ( split("\0",$gIn{'del'}) ) {
							$flag = 1 if ($ban_ip eq $del_ip);
							last if ($flag);
						}
						$gEnv{'conf'}{'ip_ban'} .= $ban_ip . '%n' if (!$flag);
					}
				} else {
					die($gMsg{'error'}{'unknown'});
				}
				&sbfile_update_conf();
				$msg = $gMsg{'parts'}{'confcomp'};
				$gIn{'mode'} = 'refuse';
				last ADMINREGI;
			};
			/^config/ && do {
				my $change_lang = 0;
				foreach my $key ( keys(%{$gEnv{'conf'}}) ) {
					next if ($key eq 'ip_ban' or $key eq 'edit_ping');
					if ($key eq 'timezone') {
						$gEnv{'conf'}{$key} = $gIn{$key} if ($gIn{$key} =~ /^([\+-])(\d\d)(\d\d)/);
					} elsif ($key eq 'blog_desc' or $key eq 'blog_title') {
						$gEnv{'conf'}{$key} = &sbtxt_decform($gIn{$key},2);
					} elsif ($key eq 'summertime') {
						$gEnv{'conf'}{$key} = ($gIn{$key} eq 'on') ? 1 : 0;
					} elsif ( index($key,'_disp') > -1 ) {
						$gIn{$key} = int($gIn{$key});
						$gIn{$key} = 1 if ($gIn{$key} < 1 and $key ne 'page_disp');
						$gEnv{'conf'}{$key} = $gIn{$key};
					} else {
						$change_lang = 1 if ($key eq 'lang' and $gEnv{'conf'}{$key} ne $gIn{$key});
						$gEnv{'conf'}{$key} = $gIn{$key};
					}
				}
				&sbfile_update_conf();
				if ($change_lang) {
					&sblock_unlock($lfile);
					print &sbhtml_http('',$gData{'{sb_site_cgi}'}[0] . '?mode=config&changed=lang','');
					exit(0);
				} else {
					$msg = '[' . $gMsg{'mode'}{'config'} . '] ' . $gMsg{'parts'}{'confcomp'} . '<br />' . $gMsg{'parts'}{'needmake'};
				}
				last ADMINREGI;
			};
			/^editor/ && do {
				$gData{'user'}[$gEnv{'currentuser'}]{'edit'}  = $gIn{'editor_stat'} . ':';
				$gData{'user'}[$gEnv{'currentuser'}]{'edit'} .= $gIn{'editor_format'} . ':';
				$gData{'user'}[$gEnv{'currentuser'}]{'edit'} .= $gIn{'editor_date'} . ':';
				$gData{'user'}[$gEnv{'currentuser'}]{'edit'} .= $gIn{'editor_comment'} . ':';
				$gData{'user'}[$gEnv{'currentuser'}]{'edit'} .= $gIn{'editor_trackback'} . ':';
				$gData{'user'}[$gEnv{'currentuser'}]{'edit'} .= $gIn{'editor_sendping'} . ':';
				$gData{'user'}[$gEnv{'currentuser'}]{'edit'} .= $gIn{'editor_sequel'} . ':';
				$gData{'user'}[$gEnv{'currentuser'}]{'edit'} .= $gIn{'editor_excerpt'} . ':';
				$gData{'user'}[$gEnv{'currentuser'}]{'edit'} .= $gIn{'editor_imagelist'};
				if ($gIn{'update_ping'} eq 'on') {
					$gEnv{'conf'}{'edit_ping'} = &sbtxt_decform($gIn{'editor_ping'},2);
				}
				&sbfile_update_datafile('user');
				&sbfile_update_conf();
				$msg = '[' . $gMsg{'mode'}{'editor'} . '] ' . $gMsg{'parts'}{'confcomp'};
				last ADMINREGI;
			};
			/^transfer/ && do {
				require 'sbutil.pl';
				if ($gIn{'import'} ne '') {
					die($gMsg{'error'}{'import_cond'} . "\n") if ($gIn{'import_user'} ne 'on' and $gIn{'import_pass'} eq '');
					die($gMsg{'error'}{'wrong_text'} . "\n") if ($gIn{'import_pass'} !~ /^\w+$/ and $gIn{'import_pass'} ne '');
					my $num = &sbutil_import($gIn{'import_data'},$gIn{'import_url'});
					$msg = $num . $gMsg{'parts'}{'import'};
				} elsif ($gIn{'export'} ne '') {
					&sbutil_export();
				} else {
					die($gMsg{'error'}{'unknown'});
				}
				last ADMINREGI;
			};
		} # end of ADMINREGI
	};
	&sblock_unlock($lfile);
	die($@ . "\n") if ($@);
	return($msg);
}
sub sbadmn_update_entry {
	my $eid = shift;
	my $msg = '';
	my ($prv,$nxt) = ();
	if ($gIn{'entry_body'} eq '' and $gIn{'entry_more'} eq '') {
		$gData{'{sb_entry_title}'}[0] = &sbtxt_decform($gIn{'entry_title'},1) if ($gIn{'entry_title'} ne '');
		$gData{'{sb_entry_summary}'}[0] = &sbtxt_lfconv(&sbtxt_decform($gIn{'entry_summary'},2),1) if ($gIn{'entry_summary'} ne '');
		$gData{'{sb_entry_add_category}'}[0] = &sbtxt_decform($gIn{'entry_add_category'},1) if ($gIn{'entry_add_category'} ne '');
		$gEnv{'editdef'} = &sbtxt_decform($gIn{'entry_category'},1) if ($gIn{'entry_category'} ne '');
		$gIn{'mode'} = 'edit';
		return($gMsg{'error'}{'no_body'});
	}
	$gIn{'entry_ping'} = '' if ($gIn{'entry_status'} == 0); # ȥ꡼ξ硢PINGʤ
	&sbfile_read_datafile('ent');
	&sbfile_read_datafile('cat');
	$eid = &sbadmn_check_entry_id($eid);
	my $creator = $gData{'entry'}{$eid}{'ent'}{'auth'};
	$creator = $gEnv{'currentuser'} if ($creator eq '' or $gData{'user'}[$creator]{'id'} eq '');
	$gData{'entry'}{$eid}{'ent'}{'id'}   = $eid;
	$gData{'entry'}{$eid}{'ent'}{'wid'}  = 0;
	$gData{'entry'}{$eid}{'ent'}{'subj'} = &sbtxt_decform($gIn{'entry_title'},1);
	$gData{'entry'}{$eid}{'ent'}{'auth'} = $creator;
	$gData{'entry'}{$eid}{'ent'}{'edit'} = $gEnv{'currentuser'};
	$gData{'entry'}{$eid}{'ent'}{'stat'} = $gIn{'entry_status'};
	$gData{'entry'}{$eid}{'ent'}{'com'}  = 0 if ($gData{'entry'}{$eid}{'ent'}{'com'} eq '');
	$gData{'entry'}{$eid}{'ent'}{'tb'}   = 0 if ($gData{'entry'}{$eid}{'ent'}{'tb'} eq '');
	$gData{'entry'}{$eid}{'ent'}{'acm'}  = $gIn{'entry_com'};
	$gData{'entry'}{$eid}{'ent'}{'atb'}  = $gIn{'entry_tb'};
	$gData{'entry'}{$eid}{'ent'}{'form'} = $gIn{'entry_format'};
	$gData{'entry'}{$eid}{'ent'}{'body'} = &sbtxt_decform($gIn{'entry_body'},2);
	$gData{'entry'}{$eid}{'ent'}{'more'} = &sbtxt_decform($gIn{'entry_more'},2);
	$gData{'entry'}{$eid}{'ent'}{'sum'}  = &sbtxt_decform($gIn{'entry_summary'},2);
	if ($gIn{'entry_add_category'} ne '') { # ƥ꡼
		$gData{'entry'}{$eid}{'ent'}{'cat'} = &sbtxt_decform($gIn{'entry_add_category'},1);
	} else {
		$gData{'entry'}{$eid}{'ent'}{'cat'} = &sbtxt_decform($gIn{'entry_category'},1);
		foreach my $hash ( @{$gData{'cat'}} ) {
			next if ($$hash{'id'} eq '');
			next if ($$hash{'name'} ne $gData{'entry'}{$eid}{'ent'}{'cat'});
			$gIn{'entry_tbping'} .= &sbtxt_det($$hash{'tb'}) . "\n" if ($$hash{'tb'} ne '');
		}
	}
	{ # 
		my $sc = $gIn{'entry_date_sc'};
		my $mi = $gIn{'entry_date_mi'};
		my $ho = $gIn{'entry_date_ho'};
		my $dy = $gIn{'entry_date_dy'};
		my $mo = $gIn{'entry_date_mo'};
		my $yr = $gIn{'entry_date_yr'};
		($prv,$nxt) = &sbadmn_search_neighbor($eid) if ($gData{'entry'}{$eid}{'ent'}{'date'});
		$gData{'entry'}{$eid}{'ent'}{'date'} = &sbtime_convtime($sc,$mi,$ho,$dy,$mo,$yr,$gEnv{'conf'}{'timezone'});
	}
	{ # ȥ꡼ꥹȤι
		my $subj = $gData{'entry'}{$eid}{'ent'}{'subj'};
		my $cate = $gData{'entry'}{$eid}{'ent'}{'cat'};
		my $date = $gData{'entry'}{$eid}{'ent'}{'date'};
		my $auth = $gData{'entry'}{$eid}{'ent'}{'auth'};
		my $stat = $gData{'entry'}{$eid}{'ent'}{'stat'};
		my $com_ = $gData{'entry'}{$eid}{'ent'}{'com'};
		my $tb__ = $gData{'entry'}{$eid}{'ent'}{'tb'};
		if ($gEnv{'newentry'}) {
			&sbini_creat_newentry($subj,$cate,$date,$auth,$stat,$com_,$tb__);
		} else {
			$gData{'ent'}[$eid]{'id'}   = $eid;
			$gData{'ent'}[$eid]{'wid'}  = 0;
			$gData{'ent'}[$eid]{'subj'} = $subj;
			$gData{'ent'}[$eid]{'cat'}  = $cate;
			$gData{'ent'}[$eid]{'date'} = $date;
			$gData{'ent'}[$eid]{'auth'} = $auth;
			$gData{'ent'}[$eid]{'stat'} = $stat;
			$gData{'ent'}[$eid]{'com'}  = $com_;
			$gData{'ent'}[$eid]{'tb'}   = $tb__;
		}
	}
	if ($gIn{'findtb'} ne '') { # ȥåХå url ư
		my $num = 0;
		my $text = $gData{'entry'}{$eid}{'ent'}{'body'} . '%n' . $gData{'entry'}{$eid}{'ent'}{'more'};
		require 'sbping.pl';
		$num = &sbping_discover_trackback($text);
		$msg = $num . $gMsg{'parts'}{'findtb'};
	} elsif ($gIn{'upload'} ne '') { # ե륢åץ
		$msg = &sbadmn_update_image();
	} else { # Ͽ
		if ($gIn{'entry_add_category'} ne '') { # ɲåƥ꡼
			&sbini_creat_newcat($gData{'entry'}{$eid}{'ent'}{'cat'},'','');
			&sbfile_update_datafile('cat');
		}
		if ($gIn{'entry_status'} != 0 and $gIn{'entry_tbping'} ne '') { # ȥåХå ping 
			require 'sbping.pl';
			my $pinglist = &sbtxt_decform($gIn{'entry_tbping'},2);
			$gIn{'entry_tbping'} = '';
			my $pingstat = &sbping_tb($pinglist,$eid) if ($pinglist ne '');
			if ($pingstat ne '') {
				$gData{'entry'}{$eid}{'ent'}{'ping'} .= $pingstat;
				$pingstat = &sbtxt_lfconv(&sbtxt_det($pingstat),1);
				foreach my $url ( split("\n",$pingstat) ) {
					$msg .= $url . $gMsg{'parts'}{'sentping'};
				}
			}
		}
		&sbfile_update_datafile('ent');
		&sbfile_update_entry($eid);
		&sbadmn_build_files($eid,$prv,$nxt);
		if ($gIn{'entry_ping'} eq 'on') {
			require 'sbping.pl';
			if ($gEnv{'conf'}{'edit_ping'} ne '') { #  ping 
				my $pingstat = &sbping_update($gEnv{'conf'}{'edit_ping'});
				if ($pingstat ne '') {
					$pingstat = &sbtxt_lfconv(&sbtxt_det($pingstat),1);
					foreach my $url ( split("\n",$pingstat) ) {
						$msg .= $url . $gMsg{'parts'}{'sentping'};
					}
				}
			}
		}
		$msg .= ($gEnv{'newentry'}) ? $gMsg{'parts'}{'new_comp'} : $gMsg{'parts'}{'editcomp'};
		$msg .= ' <a href="#" onclick="window.close()">' . $gMsg{'parts'}{'bm_close'} . '</a>' if ($gIn{'bm'} eq 'on');
		$gEnv{'newentry'} = 0 if ($gEnv{'newentry'});
	}
	$gIn{'eid'} = $eid;
	$gIn{'mode'} = 'edit';
	return($msg);
}
sub sbadmn_check_entry_id {
	my $eid = shift;
	if ($eid ne '') {
		&sbfile_read_entry($eid);
	} else {
		$eid = $gData{'num'}{'ent'};
		if ($eid > 0 and $gData{'ent'}[($eid - 1)]{'id'} ne '') {
			my $check = $eid - 1;
			&sbfile_read_entry($check);
			if ($gData{'entry'}{$check}{'ent'}{'body'} eq  &sbtxt_decform($gIn{'entry_body'},2)) {
				$eid = $check;
			} else {
				delete($gData{'entry'}{$check}); # ѥǡ
			}
		}
		$gEnv{'newentry'} = 1 if ($eid == $gData{'num'}{'ent'});
	}
	return($eid);
}
sub sbadmn_search_neighbor {
	my $eid = shift;
	my ($prv,$nxt) = ();
	my @entry = @{$gData{'ent'}};
	my $check = $#entry;
	@entry = sort { $$b{'date'} <=> $$a{'date'} } @entry;
	for (my $i=0;$i<@entry;$i++) {
		next if (${$entry[$i]}{'id'} eq '');
		next if (${$entry[$i]}{'stat'} == 0); # ȥ꡼Ф
		next if (${$entry[$i]}{'id'} != $eid);
		$check = $i;
		last;
	}
	$prv = ${$entry[$check + 1]}{'id'} if ($check < $#entry);
	$nxt = ${$entry[$check - 1]}{'id'} if ($check > 0);
	return($prv,$nxt);
}
sub sbadmn_build_files {
	my ($eid,$old_prv,$old_nxt) = @_;
	if ($gEnv{'conf'}{'entry_archive'} eq 'Individual') {
		my @lists = ($eid);
		my ($new_prv,$new_nxt) = &sbadmn_search_neighbor($eid);
		push(@lists,$old_prv) if ($old_prv ne '' and $gData{'ent'}[$old_prv]{'stat'} != 0);
		push(@lists,$old_nxt) if ($old_nxt ne '' and $gData{'ent'}[$old_nxt]{'stat'} != 0);
		push(@lists,$new_prv) if ($new_prv ne '' and $gData{'ent'}[$new_prv]{'stat'} != 0);
		push(@lists,$new_nxt) if ($old_nxt ne '' and $gData{'ent'}[$new_nxt]{'stat'} != 0);
		{ # ʣƤ id 
			my %cnt;
			@lists = grep(!$cnt{$_}++, @lists);
		}
		foreach my $list ( @lists ) {
			&sbmake_entry($list);
		}
		&sbmake_alljs();
		&sbmake_cookie_js(0);
		&sbmake_log_js(0);
		&sbmake_top();
		&sbmake_rss()  if ($gEnv{'basic'}{'gen_rss'});
		&sbmake_atom() if ($gEnv{'basic'}{'gen_atom'});
		&sbmake_css();
	} else {
		&sbmake_rebuild_all();
	}
	return();
}
sub sbadmn_delete_entry {
	my $msg = '';
	foreach my $type ('ent','com','tb') {
		&sbfile_read_datafile($type);
	}
	my $num = 0;
	for (my $i=0;$i<$gData{'num'}{'ent'};$i++) {
		next if ($gData{'ent'}[$i]{'id'} eq '');
		my $eid = $gData{'ent'}[$i]{'id'};
		if ($gIn{'del' . $eid} eq 'on') {
			&sbfile_read_entry($eid);
			for (my $j=0;$j<@{$gData{'entry'}{$eid}{'com'}};$j++) {
				my $mid = $gData{'entry'}{$eid}{'com'}[$j]{'id'};
				$gData{'com'}[$mid]{'id'} = '';
			}
			for (my $j=0;$j<@{$gData{'entry'}{$eid}{'tb'}};$j++) {
				my $bid = $gData{'entry'}{$eid}{'tb'}[$j]{'id'};
				$gData{'tb'}[$bid]{'id'} = '';
			}
			unlink($gEnv{dir}{data} . $gEnv{dir}{ent} . $eid . $gEnv{file}{suf});
			$gData{'ent'}[$i]{'id'} = '';
			$num++;
		}
	}
	$msg .= $num . $gMsg{'parts'}{'deleted'};
	foreach my $type ('ent','com','tb') {
		&sbfile_update_datafile($type);
	}
	return($msg);
}
sub sbadmn_amazon {
	my $id = shift;
	my $msg = '';
	my $mode = 'amazon';
	&sbfile_read_datafile('aws');
	if ($gIn{'del'} ne '') { # 
		if ($gData{'aws'}[$id]{'id'} ne '') {
			$gData{'aws'}[$id]{'id'} = '';
			$msg .= '1' . $gMsg{'parts'}{'deleted'};
		}
	} elsif ($gIn{'edit'} ne '') { # Խ
		if ($gData{'aws'}[$id]{'id'} ne '') {
			$gData{'aws'}[$id]{'msg'} = &sbtxt_decform($gIn{'aws_msg'},1);
			$msg .= $gMsg{'parts'}{'editcomp'};
		}
	} elsif ($gIn{'add'} ne '') { # ɲ
		if ($gIn{'aws_cre'} ne '') {
			$gIn{'aws_cre'} = &sbtxt_decform($gIn{'aws_cre'},1);
			$gIn{'aws_cre'} =~ s/\&sb;/\n/g;
			$gIn{'aws_cre'} = &sbtxt_lfconv($gIn{'aws_cre'},0);
		}
		if (index($gIn{'aws_url'},'?') > -1) {
			$gIn{'aws_url'} = substr($gIn{'aws_url'},0,index($gIn{'aws_url'},'?'));
		}
		&sbini_creat_newitem($gEnv{'currentuser'},
		                     &sbtxt_decform($gIn{'aws_name'},1),
		                     &sbtxt_decform($gIn{'aws_cat'},1),
		                     $gIn{'aws_cre'},
		                     $gIn{'aws_date'},
		                     &sbtxt_decform($gIn{'aws_make'},1),
		                     $gIn{'aws_ism'},
		                     $gIn{'aws_imd'},
		                     $gIn{'aws_ilg'},
		                     &sbtxt_decform($gIn{'aws_ava'},1),
		                     &sbtxt_decform($gIn{'aws_lpr'},1),
		                     &sbtxt_decform($gIn{'aws_opr'},1),
		                     &sbtxt_decform($gIn{'aws_msg'},2),
		                     $gIn{'aws_url'});
		$msg .= $gMsg{'parts'}{'new_comp'};
	} elsif ($gIn{'new'} ne '') { # 
		my $hash = $gData{'aws'}[$id];
		$mode = 'edit';
		$gIn{'newtext'}  = '<a href="' . $$hash{'url'} . '" target="_blank"><img src="' . $$hash{'imd'} . '" alt="' . $$hash{'name'} . '" /></a>' . "\n";
		$gIn{'newtext'} .= '<a href="' . $$hash{'url'} . '" target="_blank"><strong>' . $$hash{'name'} . '</strong></a>' . "\n\n";
		$gIn{'newtext'} .= $$hash{'msg'};
		$gData{'{sb_site_title}'}[0] = $gEnv{'admn'}{'title'} . $gMsg{'mode'}{$mode};
	} else {
		die($gMsg{'error'}{'unknown'});
	}
	&sbfile_update_datafile('aws') if ($mode eq 'amazon');
	$gIn{'mode'} = $mode;
	return($msg);
}
sub sbadmn_update_image {
	my $msg = '';
	my $dir = $gEnv{dir}{base} . $gEnv{dir}{img};
	&sbfile_read_datafile('img');
	if ($gIn{'del'} ne '') { # 
		my $num = 0;
		for (my $i=0;$i<$gData{'num'}{'img'};$i++) {
			next if ($gData{'img'}[$i]{'id'} eq '');
			if ($gIn{'del' . $gData{'img'}[$i]{'id'}} eq 'on') {
				unlink($dir . $gData{'img'}[$i]{'file'});
				unlink($dir . $gData{'img'}[$i]{'thumb'}) if ($gData{'img'}[$i]{'thumb'} ne '');
				$gData{'img'}[$i]{'id'} = '';
				$num++;
			}
		}
		$gIn{'page'} = '';
		$msg .= $num . $gMsg{'parts'}{'deleted'};
	} elsif ($gIn{'update'} ne '') { # Խ
		for (my $i=0;$i<$gData{'num'}{'img'};$i++) {
			my $id = $gData{'img'}[$i]{'id'};
			next if ($id eq '');
			$gData{'img'}[$i]{'name'} = &sbtxt_decform($gIn{'img_name' . $id},1) if ($gIn{'img_name' . $id} ne '');
			if ($gIn{'img_list' . $id} ne '' and $gIn{'img_com' . $id} ne '') {
				$gData{'img'}[$i]{'stat'} = $gIn{'img_list' . $id} . ':' . $gIn{'img_com' . $id} . ':0';
			}
		}
		$msg .= $gMsg{'parts'}{'editcomp'};
	} elsif ($gIn{'upload'} ne '') { # ɲ
		my $num = $gData{'num'}{'img'};
		my ($file,$name) = &sbfile_upload_image('img' . $num,'upload_file',$gIn{'upload_file'},$dir) if ($gIn{'upload_file'});
		if ($file ne '') { # åץ
			my $thumb = '';
			if ($gIn{'upload_thumb'} eq 'on') {
				$thumb = 'thm' . $num . '_' . $name;
				$thumb = 'thm' . $num . '_file' . &sbpict_picttail($thumb) if ($thumb =~ /[^a-zA-Z0-9_\-\.]/);
				&sbpict_creat_thumb($thumb,$file,$dir,$gEnv{'conf'}{'thumbsize'});
			}
			$name = &sbtxt_decform($gIn{'upload_name'},1) if ($gIn{'upload_name'} ne '');
			&sbini_creat_newimage($gEnv{'currentuser'},$name,$file,$thumb);
		}
		$msg .= $name . ' ' . $gMsg{'parts'}{'new_comp'};
	} else {
		die($gMsg{'error'}{'unknown'});
	}
	&sbfile_update_datafile('img');
	&sbmake_cookie_js(1);
	$gIn{'mode'} = 'upload';
	return($msg);
}
sub sbadmn_update_comtb {
	my $mode = shift;
	my $msg = '';
	my $base = ($mode eq 'comment') ? 'com' : 'tb';
	my @ents = ();
	&sbfile_read_datafile($base);
	if ($gIn{'del'} ne '') { # 
		my $num = 0;
		for (my $i=0;$i<$gData{'num'}{$base};$i++) {
			next if ($gData{$base}[$i]{'id'} eq '');
			if ($gIn{'del' . $gData{$base}[$i]{'id'}} eq 'on') {
				my $eid = $gData{$base}[$i]{'eid'};
				&sbfile_read_entry($eid);
				for (my $j=0;$j<@{$gData{'entry'}{$eid}{$base}};$j++) {
					next if ($gData{$base}[$i]{'id'} != $gData{'entry'}{$eid}{$base}[$j]{'id'});
					$gData{'entry'}{$eid}{$base}[$j]{'id'} = '';
				}
				$gData{'entry'}{$eid}{'ent'}{$base} = &sbadmn_count_comtb($eid,$base);
				&sbfile_update_entry($eid);
				$gData{$base}[$i]{'id'} = '';
				push(@ents,$eid);
				$num++;
			}
		}
		$msg .= $num . $gMsg{'parts'}{'deleted'};
	} elsif ($gIn{'stat'} ne '') { # ơѹ
		my $change = ($gData{$base}[$gIn{'id'}]{'stat'}) ? 0 : 1;
		my $eid = $gData{$base}[$gIn{'id'}]{'eid'};
		&sbfile_read_entry($eid);
		for (my $i=0;$i<@{$gData{'entry'}{$eid}{$base}};$i++) {
			next if ($gIn{'id'} != $gData{'entry'}{$eid}{$base}[$i]{'id'});
			$gData{'entry'}{$eid}{$base}[$i]{'stat'} = $change;
		}
		$gData{'entry'}{$eid}{'ent'}{$base} = &sbadmn_count_comtb($eid,$base);
		$gData{$base}[$gIn{'id'}]{'stat'} = $change;
		&sbfile_update_entry($eid);
		push(@ents,$eid);
		$msg .= $gMsg{'parts'}{'editcomp'};
	} else {
		die($gMsg{'error'}{'unknown'});
	}
	&sbfile_update_datafile($base);
	if ($gEnv{'conf'}{'entry_archive'} eq 'Individual') {
		{ # ʣƤ id 
			my %cnt;
			@ents = grep(!$cnt{$_}++, @ents);
		}
		foreach my $eid ( @ents ) {
			&sbmake_entry($eid);
		}
		&sbmake_comjs();
		&sbmake_top();
	} else {
		&sbmake_rebuild_all();
	}
	return($msg);
}
sub sbadmn_count_comtb {
	my ($eid,$mode) = @_;
	my $num = 0;
	foreach my $hash ( @{$gData{'entry'}{$eid}{$mode}} ) {
		next if ($$hash{'id'} eq '');
		next if ($$hash{'stat'} == 0);
		$num++;
	}
	return($num);
}
sub sbadmn_update_user {
	my $mode = shift;
	my $msg = '';
	if ($mode ne 'user' or $gIn{'add'} ne '') {
		die($gMsg{'error'}{'unknown'}) if ($gData{'user'}[$gIn{'pid'}]{'id'} eq '' and $mode ne 'user');
		die($gMsg{'error'}{'wrong_text'}) if ($gIn{'user_name'} !~ /^\w+$/);
		if ($gIn{'user_pass'} ne '' or $mode eq 'user') { # ѥѹ
			die($gMsg{'error'}{'wrong_text'}) if ($gIn{'user_pass'} !~ /^\w+$/);
			die($gMsg{'error'}{'difference'}) if ($gIn{'user_pass'} ne $gIn{'user_passconf'});
			if ($mode ne 'user') {
				$gData{'user'}[$gIn{'pid'}]{'pass'} = &sbtxt_crypt($gIn{'user_pass'});
				$msg .= $gMsg{'parts'}{'passchng'} if ($gIn{'pass'} ne $gIn{'user_pass'});
			}
		}
		for (my $i=0;$i<$gData{'num'}{'user'};$i++) {
			next if ($gData{'user'}[$i]{'id'} eq '');
			next if ($gData{'user'}[$i]{'id'} == $gIn{'pid'} and $mode ne 'user');
			die($gMsg{'error'}{'exist_user'}) if ($gData{'user'}[$i]{'name'} eq $gIn{'user_name'});
		}
		my $name = $gIn{'user_name'};
		my $real = &sbtxt_decform($gIn{'user_real'},1);
		my $mail = &sbtxt_decform($gIn{'user_mail'},1);
		my $aws  = &sbtxt_decform($gIn{'user_aws'},1);
		my $prof = &sbtxt_decform($gIn{'user_prof'},2);
		if ($mode ne 'user') {
			$gData{'user'}[$gIn{'pid'}]{'name'} = $name;
			$gData{'user'}[$gIn{'pid'}]{'real'} = $real;
			$gData{'user'}[$gIn{'pid'}]{'mail'} = $mail;
			$gData{'user'}[$gIn{'pid'}]{'aws'}  = $aws;
			$gData{'user'}[$gIn{'pid'}]{'prof'} = $prof;
			$msg .= $gMsg{'parts'}{'passchng'} if ($gEnv{'currentuser'} == $gIn{'pid'} and $name ne $gIn{'user'});
			$msg .= $gMsg{'parts'}{'editcomp'};
		} else {
			my $err = &sbini_creat_newuser($name,$gIn{'user_pass'},$gIn{'user_passconf'},$mail,2,$real);
			die($err) if ($err ne '');
			$msg .= $gMsg{'parts'}{'new_comp'};
		}
	} elsif ($gIn{'del'} ne '') {
		my $num = 0;
		for (my $i=0;$i<$gData{'num'}{'user'};$i++) {
			next if ($i == 0);
			next if ($gData{'user'}[$i]{'id'} eq '');
			if ($gIn{'del' . $gData{'user'}[$i]{'id'}} eq 'on') {
				$gData{'user'}[$i]{'id'} = '';
				$num++;
			}
		}
		$msg .= $num . $gMsg{'parts'}{'deleted'};
	} else {
		die($gMsg{'error'}{'unknown'});
	}
	&sbfile_update_datafile('user');
	if ($gEnv{'conf'}{'entry_archive'} eq 'Individual') {
		&sbmake_alljs();
		&sbmake_top();
	} else {
		&sbmake_rebuild_all();
	}
	$gIn{'mode'} = $mode;
	return($msg);
}
sub sbadmn_update_link {
	my $msg = '';
	&sbfile_read_datafile('link');
	if ($gIn{'new'} ne '') { # ɲ
		$gIn{'link_name'} = &sbtxt_decform($gIn{'link_name'},1);
		$gIn{'link_url'}  = &sbtxt_decform($gIn{'link_url'},1);
		&sbini_creat_newlink($gIn{'link_name'},$gIn{'link_url'});
		$msg .= $gMsg{'parts'}{'new_comp'};
	} elsif ($gIn{'update'} ne '') { # ¸Խ
		for (my $i=0;$i<$gData{'num'}{'link'};$i++) {
			my $id = $gData{'link'}[$i]{'id'};
			next if ($id eq '');
			my $name = &sbtxt_decform($gIn{'link_name' . $id},1);
			my $url  = &sbtxt_decform($gIn{'link_url' . $id},1);
			$gData{'link'}[$i]{'name'} = $name if ($name ne '');
			$gData{'link'}[$i]{'url'}  = $url;
		}
		$msg .= $gMsg{'parts'}{'editcomp'};
	} elsif ($gIn{'del'} ne '') { # ¸󥯺
		my $num = 0;
		for (my $i=0;$i<$gData{'num'}{'link'};$i++) {
			next if ($gData{'link'}[$i]{'id'} eq '');
			if ($gIn{'del' . $gData{'link'}[$i]{'id'}} eq 'on') {
				$gData{'link'}[$i]{'id'} = '';
				$num++;
			}
		}
		$msg .= $num . $gMsg{'parts'}{'deleted'};
	} else {
		die($gMsg{'error'}{'unknown'});
	}
	&sbfile_update_datafile('link');
	if ($gEnv{'conf'}{'entry_archive'} eq 'Individual') {
		&sbmake_alljs();
		&sbmake_top();
	} else {
		&sbmake_rebuild_all();
	}
	$gIn{'mode'} = 'link';
	return($msg);
}
sub sbadmn_update_category {
	my $msg = '';
	&sbfile_read_datafile('cat');
	if ($gIn{'new'} ne '') { # ɲ
		$gIn{'cat_name'} = &sbtxt_decform($gIn{'cat_name'},1);
		$gIn{'cat_text'} = &sbtxt_decform($gIn{'cat_text'},1);
		$gIn{'cat_tb'}   = &sbtxt_decform($gIn{'cat_tb'},1);
		&sbini_creat_newcat($gIn{'cat_name'},$gIn{'cat_text'},$gIn{'cat_tb'});
		$msg .= $gMsg{'parts'}{'new_comp'};
	} elsif ($gIn{'update'} ne '') { # ¸ƥ꡼Խ
		for (my $i=0;$i<$gData{'num'}{'cat'};$i++) {
			my $id = $gData{'cat'}[$i]{'id'};
			next if ($id eq '');
			my $name = &sbtxt_decform($gIn{'cat_name' . $id},1);
			my $text = &sbtxt_decform($gIn{'cat_text' . $id},1);
			my $tb   = &sbtxt_decform($gIn{'cat_tb' . $id},1);
			$tb = '' if ($tb and $tb !~ /s?https?:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+/);
			$gData{'cat'}[$i]{'name'} = $name if ($name ne '');
			$gData{'cat'}[$i]{'text'} = $text;
			$gData{'cat'}[$i]{'tb'}   = $tb;
		}
		$msg .= $gMsg{'parts'}{'editcomp'};
	} elsif ($gIn{'del'} ne '') { # ¸ƥ꡼
		my $num = 0;
		for (my $i=0;$i<$gData{'num'}{'cat'};$i++) {
			next if ($gData{'cat'}[$i]{'id'} eq '');
			if ($gIn{'del' . $gData{'cat'}[$i]{'id'}} eq 'on') {
				$gData{'cat'}[$i]{'id'} = '';
				$num++;
			}
		}
		$msg .= $num . $gMsg{'parts'}{'deleted'};
	} else {
		die($gMsg{'error'}{'unknown'});
	}
	&sbfile_update_datafile('cat');
	if ($gEnv{'conf'}{'entry_archive'} eq 'Individual') {
		&sbmake_alljs();
		&sbmake_top();
	} else {
		&sbmake_rebuild_all();
	}
	$gIn{'mode'} = 'category';
	return($msg);
}
sub sbadmn_update_template {
	my $tid = shift;
	my $msg = '';
	&sbfile_read_datafile('temp');
	if ($gIn{'del'} ne '') {
		my $num = 0;
		for (my $i=0;$i<$gData{'num'}{'temp'};$i++) {
			next if ($gData{'temp'}[$i]{'id'} eq '');
			next if ($gData{'temp'}[$i]{'use'});
			if ($gIn{'del' . $gData{'temp'}[$i]{'id'}} eq 'on') {
				$gData{'temp'}[$i]{'id'} = '';
				$num++;
			}
		}
		$msg .= $num . $gMsg{'parts'}{'deleted'};
		$gIn{'tid'} = '';
	} else {
		die($gMsg{'error'}{'unknown'}) if ($tid eq '');
		die($gMsg{'error'}{'unknown'}) if ($gData{'temp'}[$tid]{'id'} eq '');
		if ($gIn{'add'} ne '') { # ̾¸
			$gIn{'temp_name'} = &sbtxt_decform($gIn{'temp_name'},1);
			&sbini_creat_newtemp($gIn{'temp_name'},$gData{'temp'}[$tid]{'main'},$gData{'temp'}[$tid]{'css'},$gData{'temp'}[$tid]{'entry'});
			$msg .= $gMsg{'parts'}{'temp_add'};
			$gIn{'tid'} = '';
		} elsif ($gIn{'sel'} ne '') { # ѥƥץ졼ѹ
			for (my $i=0;$i<$gData{'num'}{'temp'};$i++) {
				next if ($gData{'temp'}[$i]{'id'} eq '');
				$gData{'temp'}[$i]{'use'} = ($tid == $gData{'temp'}[$i]{'id'}) ? 1 : 0;
			}
			&sbfile_update_css($gData{'temp'}[$tid]{'css'},$gEnv{dir}{base} . $gEnv{file}{css});
			$msg .= $gMsg{'parts'}{'temp_sel'} . $gMsg{'parts'}{'needmake'} . '<br />' . $gMsg{'parts'}{'temp_css'};
			$gIn{'tid'} = '';
		} elsif ($gIn{'main'} ne '') { # ١HTMLƥץ졼ȹ
			$gData{'temp'}[$tid]{'main'} = &sbtxt_decform($gIn{'template_main'},2);
			$gData{'temp'}[$tid]{'mod'} = $gNowTime;
			$msg .= $gMsg{'parts'}{'tempcomp'} . $gMsg{'parts'}{'needmake'};
		} elsif ($gIn{'entry'} ne '') { # ̥ȥ꡼HTMLƥץ졼ȹ
			$gData{'temp'}[$tid]{'entry'} = &sbtxt_decform($gIn{'template_entry'},2);
			$gData{'temp'}[$tid]{'mod'} = $gNowTime;
			$msg .= $gMsg{'parts'}{'tempcomp'} . $gMsg{'parts'}{'needmake'};
		} elsif ($gIn{'css'} ne '') { # CSSƥץ졼ȹ
			$gData{'temp'}[$tid]{'css'} = &sbtxt_decform($gIn{'template_css'},2);
			$gData{'temp'}[$tid]{'mod'} = $gNowTime;
			&sbfile_update_css($gData{'temp'}[$tid]{'css'},$gEnv{dir}{base} . $gEnv{file}{css}) if ($gData{'temp'}[$tid]{'use'});
			$msg .= ($gData{'temp'}[$tid]{'use'}) ? $gMsg{'parts'}{'temp_css'} : $gMsg{'parts'}{'editcomp'};
		} else {
			die($gMsg{'error'}{'unknown'});
		}
	}
	&sbfile_update_datafile('temp');
	$gIn{'mode'} = 'template';
	return($msg);
}
1;
